/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 */

package ca.uhn.hl7v2.model.v26.datatype;

import ca.uhn.hl7v2.model.Composite;
import ca.uhn.hl7v2.model.DataTypeException;
import ca.uhn.hl7v2.model.Message;
import ca.uhn.hl7v2.model.Type;
import ca.uhn.hl7v2.model.AbstractType;
import ca.uhn.log.HapiLogFactory;

/**
 * <p>Represents an HL7 PIP (Practitioner Institutional Privileges) data type. 
 * This type consists of the following components:</p>
 * <ul>
 * <li>Privilege (CWE)
 * <li>Privilege Class (CWE)
 * <li>Expiration Date (DT)
 * <li>Activation Date (DT)
 * <li>Facility (EI)
 * </ul>
 */
public class PIP extends AbstractType implements Composite {

    private Type[] data;

    /** 
     * Creates a new PIP type
     */
    public PIP(Message message) {
        super(message);
        init();
    }

    private void init() {
        data = new Type[5];    
        data[0] = new CWE(getMessage());
        data[1] = new CWE(getMessage());
        data[2] = new DT(getMessage());
        data[3] = new DT(getMessage());
        data[4] = new EI(getMessage());
    }


    /**
     * Returns an array containing the data elements.
     */
    public Type[] getComponents() { 
        return this.data; 
    }

    /**
     * Returns an individual data component.
     *
     * @param number The component number (0-indexed)
     * @throws DataTypeException if the given element number is out of range.
     */
    public Type getComponent(int number) throws DataTypeException { 

        try { 
            return this.data[number]; 
        } catch (ArrayIndexOutOfBoundsException e) { 
            throw new DataTypeException("Element " + number + " doesn't exist (Type " + getClass().getName() + " has only " + this.data.length + " components)"); 
        } 
    } 


    /**
     * Returns Privilege (component #1).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public CWE getPrivilege() {
       CWE ret = null;
       try {
          ret = (CWE)getComponent(0);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Privilege (component #1).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public CWE getPip1_Privilege() {
       CWE ret = null;
       try {
          ret = (CWE)getComponent(0);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns Privilege Class (component #2).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public CWE getPrivilegeClass() {
       CWE ret = null;
       try {
          ret = (CWE)getComponent(1);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Privilege Class (component #2).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public CWE getPip2_PrivilegeClass() {
       CWE ret = null;
       try {
          ret = (CWE)getComponent(1);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns Expiration Date (component #3).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public DT getExpirationDate() {
       DT ret = null;
       try {
          ret = (DT)getComponent(2);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Expiration Date (component #3).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public DT getPip3_ExpirationDate() {
       DT ret = null;
       try {
          ret = (DT)getComponent(2);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns Activation Date (component #4).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public DT getActivationDate() {
       DT ret = null;
       try {
          ret = (DT)getComponent(3);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Activation Date (component #4).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public DT getPip4_ActivationDate() {
       DT ret = null;
       try {
          ret = (DT)getComponent(3);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns Facility (component #5).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public EI getFacility() {
       EI ret = null;
       try {
          ret = (EI)getComponent(4);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Facility (component #5).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public EI getPip5_Facility() {
       EI ret = null;
       try {
          ret = (EI)getComponent(4);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }



}

